Sign in Start for free

Process Templates

Get the sharing configuration for a given process template

GET /api/platformhub/processtemplates/{slug}/share

Path Parameters

  • slug string (required)

Response

200 — The sharing configuration of the requested process template

  • IndividuallySharedSpaceIds array of string
  • SharedToAllSpaces boolean

Example Response

JSON
{
  "IndividuallySharedSpaceIds": [
    "Spaces-1",
    "..."
  ],
  "SharedToAllSpaces": true
}

List the process template versions for a given process template

GET /api/platformhub/processtemplates/{slug}/versions

Path Parameters

  • slug string (required)

Query Parameters

  • fromPublishedDate string
    Format date-time.
  • skip integer
    Number of items to skip. Defaults to zero. Minimum 0.
  • take integer
    Number of items to take. Defaults to 30. Minimum 0.
  • toPublishedDate string
    Format date-time.
  • versionMask string

Response

200 — The requested process template version

  • Description string
  • GitCommit string
  • GitRef string
    Minimum length 1.
  • Icon object
    • Color string
      Icon background colour, as a Hex string.
    • Id string
      Font Awesome Icon Id.
  • Id string
  • IsPreRelease boolean
  • Name string
    Minimum length 1.
  • Parameters array of object
    • DisplaySettings object
    • HelpText string
    • IsOptional boolean
    • Label string
    • Name string
    • Values array of object
  • PublishedDate string
    Format date-time.
  • Slug string
    Minimum length 1.
  • Steps array of object
    • Actions array of object
    • Condition enum
      Allowed values: Success, Failure, Always, Variable.
    • Id string
    • Name string
      Minimum length 1.
    • PackageRequirement enum
      Allowed values: LetOctopusDecide, BeforePackageAcquisition, AfterPackageAcquisition.
    • Properties object
    • Slug string
    • StartTrigger enum
      Allowed values: StartAfterPrevious, StartWithPrevious.
    • Type string
      Either “Step” or “ProcessTemplateUsage”. Defaults to “Step” if no type is provided.
  • Version string
    Minimum length 1.

Example Response

JSON
[
  {
    "Description": "string",
    "GitCommit": "string",
    "GitRef": "string",
    "Icon": {
      "Color": "string",
      "Id": "string"
    },
    "Id": "ProcessTemplateVersion-1",
    "IsPreRelease": true,
    "Name": "string",
    "Parameters": [
      {
        "DisplaySettings": {},
        "HelpText": "string",
        "IsOptional": true,
        "Label": "string",
        "Name": "string",
        "Values": [
          {}
        ]
      }
    ],
    "PublishedDate": "2020-01-01T00:00:00.000Z",
    "Slug": "string",
    "Steps": [
      {
        "Actions": [
          {}
        ],
        "Condition": "Success",
        "Id": "string",
        "Name": "string",
        "PackageRequirement": "LetOctopusDecide",
        "Properties": {},
        "Slug": "string",
        "StartTrigger": "StartAfterPrevious",
        "Type": "string"
      }
    ],
    "Version": "string"
  }
]

Retrieve a single published process template and its version by version mask (no space context)

GET /api/platformhub/processtemplates/{slug}/{versionMask}

Path Parameters

  • slug string (required)
  • versionMask string (required)

Response

200 — The requested published process template and its version

  • ProcessTemplate object
    • Description string
    • GitRef string
    • Icon object
    • Id string
    • Name string
    • Parameters array of object
    • Slug string
    • Steps array of object
  • ProcessTemplateVersion string
    Minimum length 1.

Example Response

JSON
{
  "ProcessTemplate": {
    "Description": "string",
    "GitRef": "string",
    "Icon": {
      "Color": "string",
      "Id": "string"
    },
    "Id": "string",
    "Name": "string",
    "Parameters": [
      {
        "DisplaySettings": {},
        "HelpText": "string",
        "IsOptional": true,
        "Label": "string",
        "Name": "string",
        "Values": [
          {}
        ]
      }
    ],
    "Slug": "string",
    "Steps": [
      {
        "Actions": [
          {}
        ],
        "Condition": "Success",
        "Id": "string",
        "Name": "string",
        "PackageRequirement": "LetOctopusDecide",
        "Properties": {},
        "Slug": "string",
        "StartTrigger": "StartAfterPrevious",
        "Type": "string"
      }
    ]
  },
  "ProcessTemplateVersion": "string"
}

Create a new process template in the provided source

POST /api/platformhub/{gitRef}/processtemplates

Path Parameters

  • gitRef string (required)

Request Body

  • ChangeDescription string
  • Description string
  • GitRef string (required)
  • Name string (required)
    Minimum length 1.

Response

201 — Created

  • Description string
  • GitRef string
  • Icon object
    • Color string
      Icon background colour, as a Hex string.
    • Id string
      Font Awesome Icon Id.
  • Id string
  • Name string
  • Parameters array of object
    • DisplaySettings object
    • HelpText string
    • IsOptional boolean
    • Label string
    • Name string
    • Values array of object
  • Slug string
  • Steps array of object
    • Actions array of object
    • Condition enum
      Allowed values: Success, Failure, Always, Variable.
    • Id string
    • Name string
      Minimum length 1.
    • PackageRequirement enum
      Allowed values: LetOctopusDecide, BeforePackageAcquisition, AfterPackageAcquisition.
    • Properties object
    • Slug string
    • StartTrigger enum
      Allowed values: StartAfterPrevious, StartWithPrevious.
    • Type string
      Either “Step” or “ProcessTemplateUsage”. Defaults to “Step” if no type is provided.

Example Request

JSON
{
  "ChangeDescription": "string",
  "Description": "string",
  "GitRef": "string",
  "Name": "string"
}

Example Response

JSON
{
  "Description": "string",
  "GitRef": "string",
  "Icon": {
    "Color": "string",
    "Id": "string"
  },
  "Id": "string",
  "Name": "string",
  "Parameters": [
    {
      "DisplaySettings": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "HelpText": "string",
      "IsOptional": true,
      "Label": "string",
      "Name": "string",
      "Values": [
        {}
      ]
    }
  ],
  "Slug": "string",
  "Steps": [
    {
      "Actions": [
        {}
      ],
      "Condition": "Success",
      "Id": "string",
      "Name": "string",
      "PackageRequirement": "LetOctopusDecide",
      "Properties": {
        "additionalProp1": {},
        "additionalProp2": {},
        "additionalProp3": {}
      },
      "Slug": "string",
      "StartTrigger": "StartAfterPrevious",
      "Type": "string"
    }
  ]
}

Get a single process template by slug

GET /api/platformhub/{gitRef}/processtemplates/{slug}

Path Parameters

  • gitRef string (required)
  • slug string (required)

Response

200 — Success

  • Description string
  • GitRef string
  • Icon object
    • Color string
      Icon background colour, as a Hex string.
    • Id string
      Font Awesome Icon Id.
  • Id string
  • Name string
  • Parameters array of object
    • DisplaySettings object
    • HelpText string
    • IsOptional boolean
    • Label string
    • Name string
    • Values array of object
  • Slug string
  • Steps array of object
    • Actions array of object
    • Condition enum
      Allowed values: Success, Failure, Always, Variable.
    • Id string
    • Name string
      Minimum length 1.
    • PackageRequirement enum
      Allowed values: LetOctopusDecide, BeforePackageAcquisition, AfterPackageAcquisition.
    • Properties object
    • Slug string
    • StartTrigger enum
      Allowed values: StartAfterPrevious, StartWithPrevious.
    • Type string
      Either “Step” or “ProcessTemplateUsage”. Defaults to “Step” if no type is provided.

Example Response

JSON
{
  "Description": "string",
  "GitRef": "string",
  "Icon": {
    "Color": "string",
    "Id": "string"
  },
  "Id": "string",
  "Name": "string",
  "Parameters": [
    {
      "DisplaySettings": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "HelpText": "string",
      "IsOptional": true,
      "Label": "string",
      "Name": "string",
      "Values": [
        {}
      ]
    }
  ],
  "Slug": "string",
  "Steps": [
    {
      "Actions": [
        {}
      ],
      "Condition": "Success",
      "Id": "string",
      "Name": "string",
      "PackageRequirement": "LetOctopusDecide",
      "Properties": {
        "additionalProp1": {},
        "additionalProp2": {},
        "additionalProp3": {}
      },
      "Slug": "string",
      "StartTrigger": "StartAfterPrevious",
      "Type": "string"
    }
  ]
}

Share new process template to spaces

POST /api/platformhub/{gitRef}/processtemplates/{slug}/share

Path Parameters

  • gitRef string (required)
  • slug string (required)

Request Body

  • GitRef string (required)
  • IndividuallySharedSpaceIds array of string (required)
  • ShareToAllSpaces boolean (required)
  • Slug string (required)
    Minimum length 1.

Response

200 — Response containing the results of the share process template command

  • IndividuallySharedSpaceIds array of string
  • IndividuallyUnsharedSpaceIds array of string
  • SharedToAllSpaces boolean

Example Request

JSON
{
  "GitRef": "string",
  "IndividuallySharedSpaceIds": [
    "Spaces-1",
    "..."
  ],
  "ShareToAllSpaces": true,
  "Slug": "string"
}

Example Response

JSON
{
  "IndividuallySharedSpaceIds": [
    "Spaces-1",
    "..."
  ],
  "IndividuallyUnsharedSpaceIds": [
    "Spaces-1",
    "..."
  ],
  "SharedToAllSpaces": true
}

Get all the available variable names for a process template

GET /api/platformhub/{gitRef}/processtemplates/{slug}/variables/names

Path Parameters

  • gitRef string (required)
  • slug string (required)

Response

200 — Success

Example Response

JSON
[
  "string"
]

Create a process template version

POST /api/platformhub/{gitRef}/processtemplates/{slug}/versions

Path Parameters

  • gitRef string (required)
  • slug string (required)

Request Body

  • GitRef string (required)
  • IsPreRelease boolean (required)
  • Slug string (required)
    Minimum length 1.
  • Version string (required)
    The version of the process template. Must follow the semantic versioning format. Minimum length 1.

Response

201 — Created

  • Description string
  • GitCommit string
  • GitRef string
    Minimum length 1.
  • Icon object
    • Color string
      Icon background colour, as a Hex string.
    • Id string
      Font Awesome Icon Id.
  • Id string
  • IsPreRelease boolean
  • Name string
    Minimum length 1.
  • Parameters array of object
    • DisplaySettings object
    • HelpText string
    • IsOptional boolean
    • Label string
    • Name string
    • Values array of object
  • PublishedDate string
    Format date-time.
  • Slug string
    Minimum length 1.
  • Steps array of object
    • Actions array of object
    • Condition enum
      Allowed values: Success, Failure, Always, Variable.
    • Id string
    • Name string
      Minimum length 1.
    • PackageRequirement enum
      Allowed values: LetOctopusDecide, BeforePackageAcquisition, AfterPackageAcquisition.
    • Properties object
    • Slug string
    • StartTrigger enum
      Allowed values: StartAfterPrevious, StartWithPrevious.
    • Type string
      Either “Step” or “ProcessTemplateUsage”. Defaults to “Step” if no type is provided.
  • Version string
    Minimum length 1.

Example Request

JSON
{
  "GitRef": "string",
  "IsPreRelease": true,
  "Slug": "string",
  "Version": "string"
}

Example Response

JSON
{
  "Description": "string",
  "GitCommit": "string",
  "GitRef": "string",
  "Icon": {
    "Color": "string",
    "Id": "string"
  },
  "Id": "ProcessTemplateVersion-1",
  "IsPreRelease": true,
  "Name": "string",
  "Parameters": [
    {
      "DisplaySettings": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "HelpText": "string",
      "IsOptional": true,
      "Label": "string",
      "Name": "string",
      "Values": [
        {}
      ]
    }
  ],
  "PublishedDate": "2020-01-01T00:00:00.000Z",
  "Slug": "string",
  "Steps": [
    {
      "Actions": [
        {}
      ],
      "Condition": "Success",
      "Id": "string",
      "Name": "string",
      "PackageRequirement": "LetOctopusDecide",
      "Properties": {
        "additionalProp1": {},
        "additionalProp2": {},
        "additionalProp3": {}
      },
      "Slug": "string",
      "StartTrigger": "StartAfterPrevious",
      "Type": "string"
    }
  ],
  "Version": "string"
}

Modify an existing process template

PUT /api/platformhub/{gitref}/processtemplates/{slug}

Path Parameters

  • gitref string (required)
  • slug string (required)

Request Body

  • ChangeDescription string
  • Description string
  • GitRef string (required)
  • Icon object
    • Color string
      Icon background colour, as a Hex string.
    • Id string
      Font Awesome Icon Id.
  • Name string (required)
    Minimum length 1.
  • Parameters array of object (required)
    • DisplaySettings object
    • HelpText string
    • IsOptional boolean
    • Label string
    • Name string
    • Values array of object
  • Slug string (required)
    Minimum length 1.
  • Steps array of object (required)
    • Actions array of object
    • Condition enum
      Allowed values: Success, Failure, Always, Variable.
    • Id string
    • Name string (required)
      Minimum length 1.
    • PackageRequirement enum
      Allowed values: LetOctopusDecide, BeforePackageAcquisition, AfterPackageAcquisition.
    • Properties object
    • Slug string
    • StartTrigger enum
      Allowed values: StartAfterPrevious, StartWithPrevious.
    • Type string
      Either “Step” or “ProcessTemplateUsage”. Defaults to “Step” if no type is provided.

Response

200 — Success

  • Description string
  • GitRef string
  • Icon object
    • Color string
      Icon background colour, as a Hex string.
    • Id string
      Font Awesome Icon Id.
  • Id string
  • Name string
  • Parameters array of object
    • DisplaySettings object
    • HelpText string
    • IsOptional boolean
    • Label string
    • Name string
    • Values array of object
  • Slug string
  • Steps array of object
    • Actions array of object
    • Condition enum
      Allowed values: Success, Failure, Always, Variable.
    • Id string
    • Name string
      Minimum length 1.
    • PackageRequirement enum
      Allowed values: LetOctopusDecide, BeforePackageAcquisition, AfterPackageAcquisition.
    • Properties object
    • Slug string
    • StartTrigger enum
      Allowed values: StartAfterPrevious, StartWithPrevious.
    • Type string
      Either “Step” or “ProcessTemplateUsage”. Defaults to “Step” if no type is provided.

Example Request

JSON
{
  "ChangeDescription": "string",
  "Description": "string",
  "GitRef": "string",
  "Icon": {
    "Color": "string",
    "Id": "string"
  },
  "Name": "string",
  "Parameters": [
    {
      "DisplaySettings": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "HelpText": "string",
      "IsOptional": true,
      "Label": "string",
      "Name": "string",
      "Values": [
        {}
      ]
    }
  ],
  "Slug": "string",
  "Steps": [
    {
      "Actions": [
        {}
      ],
      "Condition": "Success",
      "Id": "string",
      "Name": "string",
      "PackageRequirement": "LetOctopusDecide",
      "Properties": {
        "additionalProp1": {},
        "additionalProp2": {},
        "additionalProp3": {}
      },
      "Slug": "string",
      "StartTrigger": "StartAfterPrevious",
      "Type": "string"
    }
  ]
}

Example Response

JSON
{
  "Description": "string",
  "GitRef": "string",
  "Icon": {
    "Color": "string",
    "Id": "string"
  },
  "Id": "string",
  "Name": "string",
  "Parameters": [
    {
      "DisplaySettings": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "HelpText": "string",
      "IsOptional": true,
      "Label": "string",
      "Name": "string",
      "Values": [
        {}
      ]
    }
  ],
  "Slug": "string",
  "Steps": [
    {
      "Actions": [
        {}
      ],
      "Condition": "Success",
      "Id": "string",
      "Name": "string",
      "PackageRequirement": "LetOctopusDecide",
      "Properties": {
        "additionalProp1": {},
        "additionalProp2": {},
        "additionalProp3": {}
      },
      "Slug": "string",
      "StartTrigger": "StartAfterPrevious",
      "Type": "string"
    }
  ]
}

Delete an existing process template

DELETE /api/platformhub/{gitref}/processtemplates/{slug}

Path Parameters

  • gitref string (required)
  • slug string (required)

Request Body

  • ChangeDescription string
  • GitRef string (required)
  • Slug string (required)
    Minimum length 1.

Response

200 — Success

Example Request

JSON
{
  "ChangeDescription": "string",
  "GitRef": "string",
  "Slug": "string"
}

Retrieve a single process template and its version by version mask

GET /api/{spaceId}/processtemplates/{slug}/{versionMask}

Also reachable at /api/spaces/{spaceIdentifier}/processtemplates/{slug}/{versionMask}.

Path Parameters

  • slug string (required)
  • spaceId string (required)
  • versionMask string (required)

Response

200 — The requested process template and its version

  • ProcessTemplate object
    • Description string
    • GitRef string
    • Icon object
    • Id string
    • Name string
    • Parameters array of object
    • Slug string
    • Steps array of object
  • ProcessTemplateVersion string
    Minimum length 1.

Example Response

JSON
{
  "ProcessTemplate": {
    "Description": "string",
    "GitRef": "string",
    "Icon": {
      "Color": "string",
      "Id": "string"
    },
    "Id": "string",
    "Name": "string",
    "Parameters": [
      {
        "DisplaySettings": {},
        "HelpText": "string",
        "IsOptional": true,
        "Label": "string",
        "Name": "string",
        "Values": [
          {}
        ]
      }
    ],
    "Slug": "string",
    "Steps": [
      {
        "Actions": [
          {}
        ],
        "Condition": "Success",
        "Id": "string",
        "Name": "string",
        "PackageRequirement": "LetOctopusDecide",
        "Properties": {},
        "Slug": "string",
        "StartTrigger": "StartAfterPrevious",
        "Type": "string"
      }
    ]
  },
  "ProcessTemplateVersion": "string"
}

Get the icon for a given process template version

GET /api/{spaceId}/processtemplates/{slug}/{versionMask}/icon

Also reachable at /api/spaces/{spaceIdentifier}/processtemplates/{slug}/{versionMask}/icon.

Path Parameters

  • slug string (required)
  • spaceId string (required)
  • versionMask string (required)

Response

200 — Success

Example Response

JSON
"string"